//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "phonebook.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VirtualTrees"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VirtualStringTree1GetNodeDataSize(
      TBaseVirtualTree *Sender, int &NodeDataSize)
{
    NodeDataSize = sizeof(structPhonebook);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VirtualStringTree1GetText(TBaseVirtualTree *Sender,
      PVirtualNode Node, TColumnIndex Column, TVSTTextType TextType,
      WideString &CellText)
{
    if (!Node)
        return;

    structPhonebook *pPhonebook = (structPhonebook *)Sender->GetNodeData(Node);

    switch (Column)
    {
    case 0:
        CellText = pPhonebook->Name;
        break;
    case 1:
        CellText = pPhonebook->Tel;
        break;
    case 2:
        CellText = pPhonebook->Sex;
        break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
    PVirtualNode Node;
    structPhonebook *pPhonebook;

    Node = VirtualStringTree1->AddChild(NULL);
    if (Node)
    {
        pPhonebook = (structPhonebook *)VirtualStringTree1->GetNodeData(Node);
        pPhonebook->Name = "";
        pPhonebook->Tel = "02-1234-5678";
        pPhonebook->Sex = "";
    }
}
//---------------------------------------------------------------------------
